%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/jboss/on/%{name}/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define project_version 3.0.0.EmbJopr4
Name:           jopr-hibernate-plugin
Version:        3.0.0
Release:        13.EmbJopr4%{?dist}
Summary:        RHQ Hibernate Plugin

Group:          Development/Libraries
License:        ASL 2.0
URL:            http://www.rhq-project.org/display/RHQ/Plugins+-+Hibernate
# git clone git://git.fedorahosted.org/rhq/rhq.git
# cd rhq
# git checkout RHQ_3_0_0_EmbJopr4
# git checkout -b RHQ_3_0_0_EmbJopr4
# cd modules/plugins/hibernate
# tar zcf jopr-hibernate-plugin-3.0.0.EmbJopr4.tar.gz .
Source0:        %{name}-%{project_version}.tar.gz
Source1:        %{name}-jpp-depmap.xml
Source2:        %{name}-settings.xml
Source3:        %{name}-component-info.xml
#Source6:        %{name}-rhq.tar.gz
#Source8:        %{name}-jboss-embeddable-ejb3-hibernate-all.tar.gz

#Patch0:         %{name}-rhq-parent-pom.patch
#Patch2:         %{name}-rhq-core-native-system-no-sigar-dist.patch
#Patch3:         %{name}-rhq-core-plugin-container-no-augeas.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch: noarch

BuildRequires: java-devel >= 1:1.6.0
BuildRequires: jpackage-utils
BuildRequires:  maven2 >= 0:2.0.4-9
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
#BuildRequires:  maven-surefire-testng
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-ejb
BuildRequires:  maven2-plugin-war
BuildRequires:  maven2-plugin-ear
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-scm
BuildRequires:  mojo-maven2-plugin-build-helper
BuildRequires:  mojo-maven2-plugin-exec
BuildRequires:  mojo-maven2-plugin-properties
BuildRequires:  mojo-maven2-plugin-buildnumber
BuildRequires: javassist
BuildRequires: hibernate3-ejb-persistence-3.0-api
BuildRequires: hibernate3-annotations
BuildRequires: hibernate3-validator
BuildRequires: glassfish-jsf
BuildRequires: jakarta-commons-el
BuildRequires: richfaces-framework
BuildRequires: richfaces-ui
BuildRequires: jakarta-commons-codec
BuildRequires: jakarta-commons-discovery
BuildRequires: jsp_2_1_api
BuildRequires: servlet_2_5_api
BuildRequires: glassfish-jaxb

BuildRequires: codehaus-stax11-api
BuildRequires: testng
BuildRequires: regexp
BuildRequires: jakarta-commons-discovery
BuildRequires: jakarta-commons-el
BuildRequires: hsqldb
BuildRequires: slf4j
BuildRequires:  glassfish-jsf
BuildRequires:  el_1_0_api
BuildRequires:  hibernate3
BuildRequires:  hibernate3-annotations
BuildRequires:  i18nlog
BuildRequires:	jboss-parent
BuildRequires:	jboss-javaee
BuildRequires:  hsqldb
BuildRequires:  slf4j

BuildRequires:  sigar
BuildRequires:  org-mc4j-ems
BuildRequires:  rhq-common-parent
BuildRequires:  rhq-core-domain
BuildRequires:  rhq-core-parent
BuildRequires:  rhq-core-util
BuildRequires:  rhq-modules-parent
BuildRequires:  rhq-core-client-api
BuildRequires:  rhq-core-gui
BuildRequires:  rhq-core-plugin-api
BuildRequires:  rhq-jboss-as-common
BuildRequires:  rhq-parent
BuildRequires:  rhq-core-comm-api
BuildRequires:  rhq-core-native-system
BuildRequires:  rhq-core-plugin-container
BuildRequires:  rhq-plugins-parent
BuildRequires:  rhq-jmx-plugin
BuildRequires:  rhq-platform-plugin


Requires: javassist
Requires: hibernate3-ejb-persistence-3.0-api
Requires: hibernate3-annotations
Requires: hibernate3-validator
Requires: glassfish-jsf
Requires: jakarta-commons-el
Requires: richfaces-framework
Requires: richfaces-ui
Requires: jakarta-commons-codec
Requires: jakarta-commons-discovery
Requires: jsp_2_1_api
Requires: servlet_2_5_api
Requires: glassfish-jaxb

Requires: codehaus-stax11-api
Requires: regexp
Requires: jakarta-commons-discovery
Requires: jakarta-commons-el
Requires: hsqldb
Requires: slf4j
Requires:  glassfish-jsf
Requires:  el_1_0_api

#Charles has confimed 'sigar' can be removed.
#Also, testng is not a runtime requirement, this is for unit testing.
#rhq incorporates org-mc4j-ems into some JAR as I don't see this one neither 
# in the plugins nor in the WEB-INF/lib directory of the console WAR that is
# deployed into the EAP AS.  So it should perhaps be a BuildRequires only... 
#Requires:  org-mc4j-ems
#Requires:  sigar
#Requires: testng

%if 0
Requires:  rhq-common-parent
Requires:  rhq-core-domain
Requires:  rhq-core-parent
Requires:  rhq-core-util
Requires:  rhq-modules-parent
Requires:  rhq-core-client-api
Requires:  rhq-core-gui
Requires:  rhq-core-plugin-api
Requires:  rhq-jboss-as-common
Requires:  rhq-parent
Requires:  rhq-core-comm-api
Requires:  rhq-core-native-system
Requires:  rhq-core-plugin-container
Requires:  rhq-plugins-parent
Requires:  rhq-jmx-plugin
Requires:  rhq-platform-plugin
%endif

Requires: jpackage-utils
Requires: java
Requires(post): jpackage-utils
Requires(postun): jpackage-utils 


%description
A plugin for managing Hibernate services

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}
Requires: jpackage-utils

%description javadoc
API documentation for %{name}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q  -c %{name}

export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL
pushd $MAVEN_REPO_LOCAL
#tar zxf %{SOURCE6}
#tar zxf %{SOURCE8}
#%patch0 -b .sav
#%patch2 -b .sav
#%patch3 -b .sav
popd

%build

cp %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository

mvn-jpp \
        -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.test.skip=true\
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven2.jpp.mode=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Penterprise,dist,prod \
        -Ddbsetup-do-not-check-schema=true \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy javadoc:javadoc

ls -lR target

%install
rm -rf %{buildroot}

# jars
install -d -m 0755 %{buildroot}%{_javadir}
install -m 644 target/%{name}-%{project_version}.jar   %{buildroot}%{_javadir}/%{name}-%{project_version}.jar

(cd %{buildroot}%{_javadir} && for jar in *-%{project_version}*; \
    do ln -sf ${jar} `echo $jar| sed "s|-%{project_version}||g"`; done)

%add_to_maven_depmap org.jboss.on %{name} %{project_version} JPP %{name}

# poms
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -pm 644 pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 0755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/api*/* %{buildroot}%{_javadocdir}/%{name}-%{version}/
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}
rm -rf target/site/api*

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__cp} -p %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{version}-brew`
%{__sed} -i "s/@VERSION@/$tag/g" %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{project_version}.jar %{buildroot}%{repodirlib}/%{name}.jar
%{__cp} -p pom.xml %{buildroot}%{repodirlib}/%{name}.pom
%endif

%post
%update_maven_depmap

%postun
%update_maven_depmap

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_javadir}*/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Oct 18 2011 Danesh Mondegarian <dmondega@redhat.com> 3.0.0-13.EmbJopr4
- Update to embjopr 4

* Tue May 17 2011 Thomas Hauser <thauser@redhat.com> 3.0.0-11.EmbJopr3
- Rebuild 

* Thu Apr 28 2011 Yong Yang <yyang@redhat.com> 3.0.0-10.EmbJopr3
- Merge with RHEL-4-EP-5

* Tue Dec 14 2010 Yong Yang <yyang@redhat.com> 3.0.0-10.EmbJopr2
- Build with maven 2.2.1
- Add maven-deploy-plugin

* Wed Dec 08 2010 Yong Yang <yyang@redhat.com> 3.0.0-9.EmbJopr2
- Remove binary source jboss-embeddable-ejb3-hibernate-all.tar.gz
- add repolib

* Mon Sep 06 2010 Yong Yang <yyang@redhat.com> 3.0.0-8.EmbJopr2
- Rebuild

* Mon Sep 06 2010 Yong Yang <yyang@redhat.com> 3.0.0-7.EmbJopr2
- Build with rhq package

* Thu Aug 26 2010 Permaine Cheung <pcheung@redhat.com> 3.0.0-6.EmbJopr2
- Fixes Requires: and update jsp_2_0_api to jsp_2_1_api

* Sun Aug 22 2010 Yong Yang <yyang@redhat.com> 3.0.0-5.EmbJopr2
- Upgrade to 3.0.0.EmbJopr2

* Wed Aug 11 2010 Yong Yang <yyang@redhat.com> 3.0.0-4.EmbJopr
- Update rhq.tar.gz

* Wed Aug 11 2010 Yong Yang <yyang@redhat.com> 3.0.0-3.EmbJopr
- Upgrade to 3.0.0.EmbJopr

* Tue Aug 10 2010 Yong Yang <yyang@redhat.com> 3.0.0-2.B06
- Fix jar version and depmap groupId

* Mon Jul 12 2010 Yong Yang <yyang@redhat.com> 3.0.0-1.B06
- Initial build
